#include "LibDisk.h"
#include "metadata.h"
#include<string.h>
#include<unistd.h>
#include<stdlib.h>
#include<stdio.h>
   
// Create File System Image during Install
int FS_Boot(char *path){

	int ret_init,i;
	superblock *superb;
//	inode_hello *inode;
	inode_hello *root;
	inode_hello *try;
	char buf[512]={0};
	int sectorno=0;

//	memset(buf,0,SECTOR_SIZE);
	superb=(superblock *)malloc(sizeof(superblock));
	root=(inode_hello *)malloc(sizeof(inode_hello));
	try=(inode_hello *)malloc(sizeof(inode_hello));
		

	ret_init=Disk_Init();
	if(ret_init==-1){
		printf("\n Memory Low. Installation Failed.");
		return -1;
	}
	superb->magic="0xEF53";
	superb->freeinodes=99;
	superb->freeblocks=2999;
	superb->min=10;
	superb->maxfiles=100;
	superb->maxopen=25;
	superb->blocksize=SECTOR_SIZE;
	superb->reservedblk=4000;
        
        memcpy((void *)buf,(void *)superb,sizeof(superblock));
	if(Disk_Write(SUPERBLOCK,buf)!=0){
		return -1;
	}
	root->name="/";
	root->type=D;
	root->size=0;
	for(i=0;i<30;i++){
		root->blockptr[i]=-1;
	}
	root->mode=RW;
	
	
	if(Disk_Read(INODES,buf)!=0){
		return -1;
	}
        if(read_inode(2,root,Up)!=0)
		return -1;

	int retroot=bitmap_update(I,ROOT_INODE,1,Up);
	if(read_inode(2,try,Rd)!=0)
                return -1;
       
	/* call routine to update inode bitmap for updating allocated root
	and copy to inode bitmap and corresponding inode*/
	if(retroot!=0){
		printf("\n Root cannot be created!");
		return -1;
	}
				
	int ret_disk=Disk_Save(path);
	if(ret_disk!=0){
	if(Disk_Load(path)!=0){
		printf("\n Image cannot be created!");
		return -1;
		}
	}

	return 0;
}

int FS_Sync(char *path){
	if(Disk_Save(path)!=0)
		return -1;
	return 0;
}

	

		
	
	
	
            	
	








