/***

testAPI.c : File Used to test File system API

**/

#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<math.h>
#include<string.h>
#include "LibDisk.h"
#include "metadata.h"
#include<sys/time.h>

int main()
{
	
 int boot,inodeno;
 inode_hello *inodetest;
 char buf[SECTOR_SIZE]={0};
 struct timeval tv_start,tv_finish;
 double elapsed;
 inodetest=(inode_hello *)malloc(sizeof(inode_hello));

/********************************************************************/	
 gettimeofday(&tv_start,NULL);
  boot=FS_Boot("/root/Desktop/fuse-2.7.3/example/newimple/test/DiskImage");
 gettimeofday(&tv_finish,NULL);
  if(boot!=0){
	printf("\n Initialize Error");
	return -1;
	}
 elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000+((tv_finish.tv_usec-tv_start.tv_usec)/1000);
 printf("\nInitialization Time in ms=%lf",elapsed);
     if(read_inode(2,inodetest,Rd)!=0)
	return -1;
/********************************************************************/
 gettimeofday(&tv_start,NULL);
   if(lfs_getattr("/",inodetest)!=0)
     return -1;
  gettimeofday(&tv_finish,NULL);
 elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000000000+((tv_finish.tv_usec-tv_start.tv_usec)*1000);
	 printf("\nGet Attributes Time in us=%lf",elapsed);
//   printf("\n Inode name %s",inodetest->name);
  // printf("\n inode size %d",inodetest->size);
/******************************************************************/
 gettimeofday(&tv_start,NULL);
   inodeno=lfs_filecreate("/testcr",R,F);
 gettimeofday(&tv_finish,NULL);

   if(inodeno==-1){
     printf("\n Create Error ");
     return -1;
   }   
 elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000000000+((tv_finish.tv_usec-tv_start.tv_usec)*1000);
 printf("\nFile Create Time in us=%lf",elapsed);

   //printf("\ninodeno=%d",inodeno);
   memset(buf,1,SECTOR_SIZE);
/****************************************************************/
    gettimeofday(&tv_start,NULL);
   int fd=lfs_openfile("/testcr");
    gettimeofday(&tv_finish,NULL);
   if(fd==-1){
	printf("\nError Opening the File");
	return -1;
	}

   elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000000000+((tv_finish.tv_usec-tv_start.tv_usec)*1000);
         printf("\nOpen File Time in us =%lf",elapsed);

   //printf("\n File Open! %d",fd);
/****************************************************************/
   gettimeofday(&tv_start,NULL);
   int sizew=lfs_writefile(fd,(void *)buf,10);
    gettimeofday(&tv_finish,NULL);
	if(sizew==-1){
		printf("\nWrite Error");
		return -1;
	}
   elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000000000+((tv_finish.tv_usec-tv_start.tv_usec)*1000);
	 printf("\nWrite File Time in us =%lf",elapsed);


	//printf("\nFile Written 1");
/******************************************************************/
        gettimeofday(&tv_start,NULL);
  	if(lfs_fileseek(fd,2)==-1)
               return -1;
	gettimeofday(&tv_finish,NULL);
 elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000000000+((tv_finish.tv_usec-tv_start.tv_usec)*1000);
         printf("\nSeek Time in us =%lf",elapsed);

    	sizew=lfs_writefile(fd,(void *)buf,10);
        if(sizew==-1){
                printf("\nWrite Error");
                return -1;
        }
       // printf("\nFile Written 2");
/******************************************************************/
	gettimeofday(&tv_start,NULL);
   	sizew=lfs_writefile(fd,(void *)buf,512);
	gettimeofday(&tv_finish,NULL);
        if(sizew==-1){
                printf("\nWrite Error");
                return -1;
        }
	 elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000000000+((tv_finish.tv_usec-tv_start.tv_usec)*1000);
         printf("\nBigger Write Time in us =%lf",elapsed);

    //    printf("\nFile Written 3");
/*******************************************************************/
	if(lfs_fileseek(fd,256)==-1)
               return -1;
	if(lfs_getattr("/testcr",inodetest)!=0)
	     return -1;
  // printf("\n Inode name %s",inodetest->name);
  // printf("\n inode size %d",inodetest->size);

	memset(buf,0,SECTOR_SIZE);
/*****************************************************************/
        gettimeofday(&tv_start,NULL);
	sizew=lfs_readfile(fd,(void *)buf,512);
	gettimeofday(&tv_finish,NULL);
        if(sizew==-1){
                printf("\nRead Error");
                return -1;
        }
        printf("\nRead!:)%d",sizew);
 elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000000000+((tv_finish.tv_usec-tv_start.tv_usec)*1000);
         printf("\nRead File Time in us =%lf",elapsed);
/*******************************************************************/
 gettimeofday(&tv_start,NULL);
	if(lfs_close(fd)==-1){
	printf("\nError Closing the File");
	return -1;
	}
gettimeofday(&tv_finish,NULL);

 elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000000000+((tv_finish.tv_usec-tv_start.tv_usec)*1000);
         printf("\nFile Close Time in us=%lf",elapsed);
/*******************************************************************/
       printf("\nfile Closed!");

 gettimeofday(&tv_start,NULL);
	if(lfs_fileunlink("/testcr")!=0){
		printf("\nUnlink Error");
		return -1;
	}
 gettimeofday(&tv_finish,NULL);
 elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000000000+((tv_finish.tv_usec-tv_start.tv_usec)*1000);
         printf("\nFile Unlink Time in us =%lf",elapsed);

	//printf("\n Unlink !");
/**********************************************************/
	 inodeno=lfs_filecreate("/Kanchan",R,D);
	if(inodeno==-1){
     		printf("\n Create Error ");
	     return -1;
   	}

/**********************************************************/
  gettimeofday(&tv_start,NULL);
	if(lfs_dirread("/",(void *)buf,1)==-1){
		printf("\nRead dir error");
		return -1;
	}
   gettimeofday(&tv_finish,NULL);
 elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000000000+((tv_finish.tv_usec-tv_start.tv_usec)*1000);
         printf("\nRead Dir Time in us=%lf",elapsed);

//	printf("\n Dir read!");
/**********************************************************/
	gettimeofday(&tv_start,NULL);
	if(lfs_dirunlink("/Kanchan")!=0){
		printf("\nDir Unlink Error");
		return -1;
	}
	gettimeofday(&tv_finish,NULL);
 elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000000000+((tv_finish.tv_usec-tv_start.tv_usec)*1000);
         printf("\nDelete Dir Time in us =%lf",elapsed);

//	printf("\n Dir Unlinked	!");
/*************************************************************/
gettimeofday(&tv_start,NULL);
boot=FS_Sync("/root/Desktop/fuse-2.7.3/example/newimple/test/DiskImage");
gettimeofday(&tv_finish,NULL);

elapsed=(tv_finish.tv_sec-tv_start.tv_sec)*1000+((tv_finish.tv_usec-tv_start.tv_usec)/1000);
         printf("\nSync Time in ms =%lf",elapsed);
printf("\n");
	if(boot!=0)
	  return -1;	
	if(Disk_Free()!=0)
		return -1;

free(inodetest);
return 0;
}
 	
		
 





