/***

testfuse.h : Header file to test fuse interface

***/


#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>

#define ENOINT -1;


typedef struct fuseop{
  int flags;
  unsigned long fh_old;
  int writepage;
  unsigned int direct_io:1;
  unsigned int keep_cache:1;
  unsigned int flush :1;
  unsigned int padding:29;
  uint64_t fh;
  uint64_t lock_owner;
}fuse_file_info;

static int fl_getattr(const char *path, struct stat *stbuf);
static int fl_readdir(const char *path, void *buf, fuse_fill_dir_t filler,
		      off_t offset, struct fuse_file_info *fi);
static int fl_mkdir(const char *path, mode_t mode);
static int fl_unlink(const char *path);
static int fl_rmdir(const char *path);
static int fl_rename(const char *from, const char *to);
static int fl_truncate(const char *path, off_t size);
static int fl_open(const char *path, struct fuse_file_info *fi);
static int fl_read(const char *path, char *buf, size_t size, off_t offset,
		   struct fuse_file_info *fi);
static int fl_write(const char *path, const char *buf, size_t size,
		    off_t offset, struct fuse_file_info *fi);
static int fl_fsync(const char *path, int isdatasync,
		    struct fuse_file_info *fi);





 

